<?php
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
$_PLUGINS->registerFunction( 'onAfterLogin', 'AnnounceLogin', 'getFriendUpdatesTab' );
$_PLUGINS->registerFunction( 'onBeforeLogout', 'AnnounceLogout', 'getFriendUpdatesTab' );
$_PLUGINS->registerFunction( 'onAfterUserUpdate', 'AnnounceProfileUpdate', 'getFriendUpdatesTab' );
$_PLUGINS->registerFunction( 'onAfterUserAvatarUpdate', 'AnnounceAvatarUpdate', 'getFriendUpdatesTab' );

class getFriendUpdatesTab extends cbTabHandler {
	function getFriendUpdatesTab() {
		$this->cbTabHandler();
	} //Announcer
	function Announce($what, $name, $nameid) {
		global $database;
		if ($what != '') {
			$query = "INSERT INTO #__comprofiler_plug_friendsupdates (time,name,nameid,text) VALUES ('"
				.time()."','"
				.mysql_real_escape_string($name)."','"
				.mysql_real_escape_string($nameid)."','"
				.mysql_real_escape_string($what)."')";
			$database->setQuery($query);
			if (!$database->query()) die($database->stderr(true));
		}
		return null;
	} // Login
	function AnnounceLogin ($row, &$tf) {
		$params = $this->params;
		if ($params->get('AnnounceLogin','1') != '0' )
			return getFriendUpdatesTab::Announce(
				$params->get('AnnounceLoginText','logged in.')
				,'<a href=\"index.php?option=com_comprofiler&task=userProfile&user='.$row->id.'\">'.$row->username.'</a>'
				,$row->id
			);
		else
			return false;
	} // Logout
	function AnnounceLogout ($row, &$tf) {
		$params = $this->params;
		if ($params->get('AnnounceLogout','1') != '0' )
			return getFriendUpdatesTab::Announce(
				$params->get('AnnounceLogoutText','logged out.')
				,'<a href=\"index.php?option=com_comprofiler&task=userProfile&user='.$row->id.'\">'.$row->username.'</a>'
				,$row->id
			);
		else
			return false;
	} // Profile Update
	function AnnounceProfileUpdate ($row, $tf) {
		$params = $this->params;
		if ($params->get('AnnounceProfileUpdate','1') != '0' )
			return getFriendUpdatesTab::Announce(
				$params->get('AnnounceProfileUpdateText','updated their profile.')
				,'<a href=\"index.php?option=com_comprofiler&task=userProfile&user='.$row->id.'\">'.$row->username.'</a>'
				,$row->id
			);
		else
			return false;
	} // Avatar Update
	function AnnounceAvatarUpdate ($row) {
		$params = $this->params;
		if ($params->get('AnnounceAvatarUpdate','1') != '0' )
			return getFriendUpdatesTab::Announce(
				$params->get('AnnounceAvatarUpdateText','updated their avatar.')
				,'<a href=\"index.php?option=com_comprofiler&task=userProfile&user='.$row->id.'\">'.$row->username.'</a>'
				,$row->id
			);
		else
			return false;
	} // DisplayTab
	function getDisplayTab($tab,$user,$ui) {
			global $database, $my;
			$params=$this->params;
			$return ="";
			
		// The number of comments that should show up in one viewing.
		$jal_number_of_comments = 35;
		
		// Works out the time since the entry post, takes a an argument in unix time (seconds)
		function jal_time_since($original) {
			// array of time period chunks
			$chunks = array(
				array(60 * 60 * 24 * 365 , 'year' , 'years'),
				array(60 * 60 * 24 * 30 , 'month' , 'months'),
				array(60 * 60 * 24 * 7, 'week' , 'weeks'),
				array(60 * 60 * 24 , 'day' , 'days'),
				array(60 * 60 , 'hour' , 'hours'),
				array(60 , 'minute' , 'minutes'),
			);
			$original = $original - 10; // Shaves a second, eliminates a bug where $time and $original match.
			$today = time(); /* Current unix time  */
			$since = $today - $original;
			
			// $j saves performing the count function each time around the loop
			for ($i = 0, $j = count($chunks); $i < $j; $i++) {
				
				$seconds = $chunks[$i][0];
				$name = $chunks[$i][1];
				$names = $chunks[$i][2];
				
				// finding the biggest chunk (if the chunk fits, break)
				if (($count = floor($since / $seconds)) != 0) {
					break;
				}
			}
		
			$print = ($count == 1) ? '1 '.$name : "$count {$names}";
			
			if ($i + 1 < $j) {
				// now getting the second item
				$seconds2 = $chunks[$i + 1][0];
				$name2 = $chunks[$i + 1][1];
				$names2 = $chunks[$i + 1][2];
				
				// add second item if it's greater than 0
				if (($count2 = floor(($since - ($seconds * $count)) / $seconds2)) != 0) {
					$print .= ($count2 == 1) ? ', 1 '.$name2 : ", $count2 {$names2}";
				}
			}
		return $print;
		}
								// Clean Out Old Updates
								$check = "SELECT *"
									 . "\n FROM #__comprofiler_plug_friendsupdates"
									 . "\n WHERE nameid=".$my->id;
								$database->setQuery( $check );
								$cleancount = $database->loadObjectList();
								if (count($cleancount)>$params->get('UpdateClean','10')){
                                $query = "DELETE FROM #__comprofiler_plug_friendsupdates WHERE nameid=".$my->id." "
                                       . "ORDER BY id ASC LIMIT 1";
                                $database->setQuery($query);
								$cleanup = $database->query();
								}
								
								// Query Updates
								$sql = "SELECT *"
									 . "\n FROM #__comprofiler_plug_friendsupdates AS a, #__comprofiler_members as b"
									 . "\n WHERE b.memberid = a.nameid"
									 . "\n AND b.referenceid=".$my->id
									 . "\n AND b.accepted=1 AND b.pending=0"
									 . "\n ORDER BY a.id DESC LIMIT ".$params->get('UpdateLimit','20');
								$database->setQuery( $sql );
								$results = $database->loadObjectList();
																
								// Owner Check
								$isProfOwner=($my->id==$user->id);
								
								// Will only add the last message div if it is looping for the first time
								$jal_first_time = true; 
								
								// Loops the messages into a list
								if($results) {foreach( $results as $r ) { 
								
										if (!$isProfOwner) {
										return ;
										} else {
								
								// Update Display
								
								$r->text = $r->text;

								if ($jal_first_time == true) { $return .= '<div style="'.$params->get('LatestUpdatestyle','').'" id="lastMessage"><span>Latest Update:</span> <em id="responseTime">'.jal_time_since( $r->time ).' ago</em></div>'; 
 						 		$return .= '<div style="'.$params->get('divstyle','').'">';			
								}
 						if ($jal_first_time == true) $lastID = $r->id;
 						$url = (empty($r->url) && $r->url = "http://") ? $r->name : '<a href="'.$r->url.'">'.$r->name.'</a>';
						        $return .= '<table width="100%"><tr><td><div><span style="'.$params->get('Usernamestyle','').'" title="'.jal_time_since( $r->time ).'">'.stripslashes($url).' : </span><span style="'.$params->get('Updatestyle','').'">'.$r->text.'</span></div></td></tr></table>';
						
					$jal_first_time = false; 
								
						}
										}
					
					// If there is less than one entry in the box
					$return .= '</div>';
					return $return;
					} else {
					return ;
					}
}
}
?>